#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "plugin.h"


MINIGRAPHIC *ImageIt(MINIGRAPHICPARAM *param, int preview,
		     int fliph, int flipv, int rot, MINIGRAPHIC *src)
{
  MINIGRAPHIC *tmp;
  int i, x, y;
  unsigned char a, *linePtr;

  // Rotations of >=180 are really flips!
  if (rot==180) {
    fliph = fliph?FALSE:TRUE;
    flipv = flipv?FALSE:TRUE;
    rot = 0;
  } else if (rot==270) {
    fliph = fliph?FALSE:TRUE;
    flipv = flipv?FALSE:TRUE;
    rot = 90;
  }

  switch(rot) {
  case 0:
    tmp = param->CreateMiniGraphic( src->width, src->height );
    memcpy(tmp->bits, src->bits, src->height*src->lineWidth);
    break;

  case 90:
    tmp = param->CreateMiniGraphic( src->height, src->width );
    for (y=0; y<(int)src->height; y++) {
      for (x=0; x<(int)src->width; x++) {
	tmp->bits[x*tmp->lineWidth+y*3+0] = src->bits[y*src->lineWidth+x*3+0];
	tmp->bits[x*tmp->lineWidth+y*3+1] = src->bits[y*src->lineWidth+x*3+1];
	tmp->bits[x*tmp->lineWidth+y*3+2] = src->bits[y*src->lineWidth+x*3+2];
      }
    }
    flipv = flipv?FALSE:TRUE;
    break;
  }

  if (fliph) {
    for (y=0; y<(int)tmp->height; y++) {
      linePtr = tmp->bits+y*tmp->lineWidth;
      for (x=0; x<(int)tmp->width/2; x++) {
	a = linePtr[x*3+0];
	linePtr[x*3+0] = linePtr[(tmp->width-x-1)*3+0];
	linePtr[(tmp->width-x-1)*3+0] = a;

	a = linePtr[x*3+1];
	linePtr[x*3+1] = linePtr[(tmp->width-x-1)*3+1];
	linePtr[(tmp->width-x-1)*3+1] = a;

	a = linePtr[x*3+2];
	linePtr[x*3+2] = linePtr[(tmp->width-x-1)*3+2];
	linePtr[(tmp->width-x-1)*3+2] = a;
      }
    }
  }

  if (flipv) {
    linePtr = (unsigned char *)LocalAlloc(LMEM_FIXED, tmp->lineWidth);
    for (i=0; linePtr!=NULL && i<(int)tmp->height/2; i++) {
      memcpy(linePtr, tmp->bits+i*tmp->lineWidth, tmp->lineWidth);
      memcpy(tmp->bits+i*tmp->lineWidth,
	     tmp->bits+(tmp->height-i-1)*tmp->lineWidth,
	     tmp->lineWidth);
      memcpy(tmp->bits+(tmp->height-i-1)*tmp->lineWidth,
	     linePtr,
	     tmp->lineWidth);
    }
    if (linePtr) LocalFree(linePtr);
  }

  return tmp;
}

